diff -ruNp linux-2.6.34.5/mm/mmap.c linux-2.6.34.5-cher1/mm/mmap.c
--- linux-2.6.34.5/mm/mmap.c	2010-08-20 22:52:05.000000000 +0400
+++ linux-2.6.34.5-cher1/mm/mmap.c	2010-08-26 14:45:12.700562237 +0400
@@ -267,8 +267,13 @@ SYSCALL_DEFINE1(brk, unsigned long, brk)
 	 */
 	rlim = rlimit(RLIMIT_DATA);
 	if (rlim < RLIM_INFINITY && (brk - mm->start_brk) +
-			(mm->end_data - mm->start_data) > rlim)
+			(mm->end_data - mm->start_data) > rlim) {
+		if ((current->sbox_flags & SBOX_MEMLIMITON)) {
+			current->sbox_flags |= SBOX_WAS_MEMLIMIT;
+			send_sig(SIGKILL, current, 0);
+		}
 		goto out;
+	}
 
 	newbrk = PAGE_ALIGN(brk);
 	oldbrk = PAGE_ALIGN(mm->brk);
@@ -1654,8 +1659,13 @@ static int acct_stack_growth(struct vm_a
 		return -ENOMEM;
 
 	/* Stack limit test */
-	if (size > ACCESS_ONCE(rlim[RLIMIT_STACK].rlim_cur))
+	if (size > ACCESS_ONCE(rlim[RLIMIT_STACK].rlim_cur)) {
+		if ((current->sbox_flags & SBOX_MEMLIMITON)) {
+			current->sbox_flags |= SBOX_WAS_MEMLIMIT;
+			send_sig(SIGKILL, current, 0);
+		}
 		return -ENOMEM;
+	}
 
 	/* mlock limit tests */
 	if (vma->vm_flags & VM_LOCKED) {
@@ -2375,8 +2385,13 @@ int may_expand_vm(struct mm_struct *mm, 
 
 	lim = rlimit(RLIMIT_AS) >> PAGE_SHIFT;
 
-	if (cur + npages > lim)
+	if (cur + npages > lim) {
+		if ((current->sbox_flags & SBOX_MEMLIMITON)) {
+			current->sbox_flags |= SBOX_WAS_MEMLIMIT;
+			send_sig(SIGKILL, current, 0);
+		}
 		return 0;
+	}
 	return 1;
 }
 
diff -ruNp linux-2.6.34.5/mm/mprotect.c linux-2.6.34.5-cher1/mm/mprotect.c
--- linux-2.6.34.5/mm/mprotect.c	2010-08-20 22:52:05.000000000 +0400
+++ linux-2.6.34.5-cher1/mm/mprotect.c	2010-08-26 14:45:12.711557228 +0400
@@ -229,6 +229,9 @@ SYSCALL_DEFINE3(mprotect, unsigned long,
 	if (grows == (PROT_GROWSDOWN|PROT_GROWSUP)) /* can't be both */
 		return -EINVAL;
 
+        if (SBOX_IS_RESTRICTED())
+		return -EPERM;
+
 	if (start & ~PAGE_MASK)
 		return -EINVAL;
 	if (!len)
diff -ruNp linux-2.6.34.5/mm/mremap.c linux-2.6.34.5-cher1/mm/mremap.c
--- linux-2.6.34.5/mm/mremap.c	2010-08-20 22:52:05.000000000 +0400
+++ linux-2.6.34.5-cher1/mm/mremap.c	2010-08-26 14:45:12.712578951 +0400
@@ -513,6 +513,9 @@ SYSCALL_DEFINE5(mremap, unsigned long, a
 {
 	unsigned long ret;
 
+        if (SBOX_IS_RESTRICTED())
+        	return -EPERM;
+
 	down_write(&current->mm->mmap_sem);
 	ret = do_mremap(addr, old_len, new_len, flags, new_addr);
 	up_write(&current->mm->mmap_sem);
diff -ruNp linux-2.6.34.5/mm/swapfile.c linux-2.6.34.5-cher1/mm/swapfile.c
--- linux-2.6.34.5/mm/swapfile.c	2010-08-20 22:52:05.000000000 +0400
+++ linux-2.6.34.5-cher1/mm/swapfile.c	2010-08-26 14:45:12.714572598 +0400
@@ -1534,6 +1534,11 @@ SYSCALL_DEFINE1(swapoff, const char __us
 	int i, type, prev;
 	int err;
 
+	if (SBOX_IS_RESTRICTED()) {
+		SBOX_SET_SECURITY_ERR();
+		return -EPERM;
+	}
+
 	if (!capable(CAP_SYS_ADMIN))
 		return -EPERM;
 
@@ -1804,6 +1809,11 @@ SYSCALL_DEFINE2(swapon, const char __use
 	struct inode *inode = NULL;
 	int did_down = 0;
 
+	if (SBOX_IS_RESTRICTED()) {
+		SBOX_SET_SECURITY_ERR();
+		return -EPERM;
+	}
+
 	if (!capable(CAP_SYS_ADMIN))
 		return -EPERM;
 
diff -ruNp linux-2.6.34.5/net/compat.c linux-2.6.34.5-cher1/net/compat.c
--- linux-2.6.34.5/net/compat.c	2010-08-20 22:52:05.000000000 +0400
+++ linux-2.6.34.5-cher1/net/compat.c	2010-08-26 14:45:12.727557255 +0400
@@ -391,6 +391,11 @@ asmlinkage long compat_sys_setsockopt(in
 	int err;
 	struct socket *sock;
 
+	if (SBOX_IS_RESTRICTED()) {
+		SBOX_SET_SECURITY_ERR();
+		return -EPERM;
+	}
+
 	if ((sock = sockfd_lookup(fd, &err))!=NULL)
 	{
 		err = security_socket_setsockopt(sock,level,optname);
@@ -504,6 +509,11 @@ asmlinkage long compat_sys_getsockopt(in
 	int err;
 	struct socket *sock;
 
+	if (SBOX_IS_RESTRICTED()) {
+		SBOX_SET_SECURITY_ERR();
+		return -EPERM;
+	}
+
 	if ((sock = sockfd_lookup(fd, &err))!=NULL)
 	{
 		err = security_socket_getsockopt(sock, level,
@@ -760,6 +770,11 @@ asmlinkage long compat_sys_recvmmsg(int 
 	int datagrams;
 	struct timespec ktspec;
 
+	if (SBOX_IS_RESTRICTED()) {
+		SBOX_SET_SECURITY_ERR();
+		return -EPERM;
+	}
+
 	if (timeout == NULL)
 		return __sys_recvmmsg(fd, (struct mmsghdr __user *)mmsg, vlen,
 				      flags | MSG_CMSG_COMPAT, NULL);
@@ -781,6 +796,11 @@ asmlinkage long compat_sys_socketcall(in
 	u32 a[6];
 	u32 a0, a1;
 
+	if (SBOX_IS_RESTRICTED()) {
+		SBOX_SET_SECURITY_ERR();
+		return -EPERM;
+	}
+
 	if (call < SYS_SOCKET || call > SYS_RECVMMSG)
 		return -EINVAL;
 	if (copy_from_user(a, args, nas[call]))
diff -ruNp linux-2.6.34.5/net/socket.c linux-2.6.34.5-cher1/net/socket.c
--- linux-2.6.34.5/net/socket.c	2010-08-20 22:52:05.000000000 +0400
+++ linux-2.6.34.5-cher1/net/socket.c	2010-08-26 14:45:12.728572551 +0400
@@ -1297,6 +1297,11 @@ SYSCALL_DEFINE3(socket, int, family, int
 	struct socket *sock;
 	int flags;
 
+	if (SBOX_IS_RESTRICTED()) {
+		SBOX_SET_SECURITY_ERR();
+		return -EPERM;
+	}
+
 	/* Check the SOCK_* constants for consistency.  */
 	BUILD_BUG_ON(SOCK_CLOEXEC != O_CLOEXEC);
 	BUILD_BUG_ON((SOCK_MAX | SOCK_TYPE_MASK) != SOCK_TYPE_MASK);
@@ -1340,6 +1345,11 @@ SYSCALL_DEFINE4(socketpair, int, family,
 	struct file *newfile1, *newfile2;
 	int flags;
 
+	if (SBOX_IS_RESTRICTED()) {
+		SBOX_SET_SECURITY_ERR();
+		return -EPERM;
+	}
+
 	flags = type & ~SOCK_TYPE_MASK;
 	if (flags & ~(SOCK_CLOEXEC | SOCK_NONBLOCK))
 		return -EINVAL;
@@ -1419,6 +1429,11 @@ SYSCALL_DEFINE3(bind, int, fd, struct so
 	struct sockaddr_storage address;
 	int err, fput_needed;
 
+	if (SBOX_IS_RESTRICTED()) {
+		SBOX_SET_SECURITY_ERR();
+		return -EPERM;
+	}
+
 	sock = sockfd_lookup_light(fd, &err, &fput_needed);
 	if (sock) {
 		err = move_addr_to_kernel(umyaddr, addrlen, (struct sockaddr *)&address);
@@ -1448,6 +1463,11 @@ SYSCALL_DEFINE2(listen, int, fd, int, ba
 	int err, fput_needed;
 	int somaxconn;
 
+	if (SBOX_IS_RESTRICTED()) {
+		SBOX_SET_SECURITY_ERR();
+		return -EPERM;
+	}
+
 	sock = sockfd_lookup_light(fd, &err, &fput_needed);
 	if (sock) {
 		somaxconn = sock_net(sock->sk)->core.sysctl_somaxconn;
@@ -1483,6 +1503,11 @@ SYSCALL_DEFINE4(accept4, int, fd, struct
 	int err, len, newfd, fput_needed;
 	struct sockaddr_storage address;
 
+	if (SBOX_IS_RESTRICTED()) {
+		SBOX_SET_SECURITY_ERR();
+		return -EPERM;
+	}
+
 	if (flags & ~(SOCK_CLOEXEC | SOCK_NONBLOCK))
 		return -EINVAL;
 
@@ -1573,6 +1598,11 @@ SYSCALL_DEFINE3(connect, int, fd, struct
 	struct sockaddr_storage address;
 	int err, fput_needed;
 
+	if (SBOX_IS_RESTRICTED()) {
+		SBOX_SET_SECURITY_ERR();
+		return -EPERM;
+	}
+
 	sock = sockfd_lookup_light(fd, &err, &fput_needed);
 	if (!sock)
 		goto out;
@@ -1605,6 +1635,11 @@ SYSCALL_DEFINE3(getsockname, int, fd, st
 	struct sockaddr_storage address;
 	int len, err, fput_needed;
 
+	if (SBOX_IS_RESTRICTED()) {
+		SBOX_SET_SECURITY_ERR();
+		return -EPERM;
+	}
+
 	sock = sockfd_lookup_light(fd, &err, &fput_needed);
 	if (!sock)
 		goto out;
@@ -1636,6 +1671,11 @@ SYSCALL_DEFINE3(getpeername, int, fd, st
 	struct sockaddr_storage address;
 	int len, err, fput_needed;
 
+	if (SBOX_IS_RESTRICTED()) {
+		SBOX_SET_SECURITY_ERR();
+		return -EPERM;
+	}
+
 	sock = sockfd_lookup_light(fd, &err, &fput_needed);
 	if (sock != NULL) {
 		err = security_socket_getpeername(sock);
@@ -1672,6 +1712,11 @@ SYSCALL_DEFINE6(sendto, int, fd, void __
 	struct iovec iov;
 	int fput_needed;
 
+	if (SBOX_IS_RESTRICTED()) {
+		SBOX_SET_SECURITY_ERR();
+		return -EPERM;
+	}
+
 	sock = sockfd_lookup_light(fd, &err, &fput_needed);
 	if (!sock)
 		goto out;
@@ -1729,6 +1774,11 @@ SYSCALL_DEFINE6(recvfrom, int, fd, void 
 	int err, err2;
 	int fput_needed;
 
+	if (SBOX_IS_RESTRICTED()) {
+		SBOX_SET_SECURITY_ERR();
+		return -EPERM;
+	}
+
 	sock = sockfd_lookup_light(fd, &err, &fput_needed);
 	if (!sock)
 		goto out;
@@ -1778,6 +1828,11 @@ SYSCALL_DEFINE5(setsockopt, int, fd, int
 	int err, fput_needed;
 	struct socket *sock;
 
+	if (SBOX_IS_RESTRICTED()) {
+		SBOX_SET_SECURITY_ERR();
+		return -EPERM;
+	}
+
 	if (optlen < 0)
 		return -EINVAL;
 
@@ -1812,6 +1867,11 @@ SYSCALL_DEFINE5(getsockopt, int, fd, int
 	int err, fput_needed;
 	struct socket *sock;
 
+	if (SBOX_IS_RESTRICTED()) {
+		SBOX_SET_SECURITY_ERR();
+		return -EPERM;
+	}
+
 	sock = sockfd_lookup_light(fd, &err, &fput_needed);
 	if (sock != NULL) {
 		err = security_socket_getsockopt(sock, level, optname);
@@ -1841,6 +1901,11 @@ SYSCALL_DEFINE2(shutdown, int, fd, int, 
 	int err, fput_needed;
 	struct socket *sock;
 
+	if (SBOX_IS_RESTRICTED()) {
+		SBOX_SET_SECURITY_ERR();
+		return -EPERM;
+	}
+
 	sock = sockfd_lookup_light(fd, &err, &fput_needed);
 	if (sock != NULL) {
 		err = security_socket_shutdown(sock, how);
@@ -1877,6 +1942,11 @@ SYSCALL_DEFINE3(sendmsg, int, fd, struct
 	int err, ctl_len, iov_size, total_len;
 	int fput_needed;
 
+	if (SBOX_IS_RESTRICTED()) {
+		SBOX_SET_SECURITY_ERR();
+		return -EPERM;
+	}
+
 	err = -EFAULT;
 	if (MSG_CMSG_COMPAT & flags) {
 		if (get_compat_msghdr(&msg_sys, msg_compat))
@@ -2070,6 +2140,11 @@ SYSCALL_DEFINE3(recvmsg, int, fd, struct
 	struct msghdr msg_sys;
 	struct socket *sock = sockfd_lookup_light(fd, &err, &fput_needed);
 
+	if (SBOX_IS_RESTRICTED()) {
+		SBOX_SET_SECURITY_ERR();
+		return -EPERM;
+	}
+
 	if (!sock)
 		goto out;
 
@@ -2192,6 +2267,11 @@ SYSCALL_DEFINE5(recvmmsg, int, fd, struc
 	int datagrams;
 	struct timespec timeout_sys;
 
+	if (SBOX_IS_RESTRICTED()) {
+		SBOX_SET_SECURITY_ERR();
+		return -EPERM;
+	}
+
 	if (!timeout)
 		return __sys_recvmmsg(fd, mmsg, vlen, flags, NULL);
 
@@ -2234,6 +2314,11 @@ SYSCALL_DEFINE2(socketcall, int, call, u
 	int err;
 	unsigned int len;
 
+	if (SBOX_IS_RESTRICTED()) {
+		SBOX_SET_SECURITY_ERR();
+		return -EPERM;
+	}
+
 	if (call < 1 || call > SYS_RECVMMSG)
 		return -EINVAL;
 
diff -ruNp linux-2.6.34.5/security/keys/keyctl.c linux-2.6.34.5-cher1/security/keys/keyctl.c
--- linux-2.6.34.5/security/keys/keyctl.c	2010-08-20 22:52:05.000000000 +0400
+++ linux-2.6.34.5-cher1/security/keys/keyctl.c	2010-08-26 14:45:12.738562093 +0400
@@ -66,6 +66,11 @@ SYSCALL_DEFINE5(add_key, const char __us
 	long ret;
 	bool vm;
 
+	if (SBOX_IS_RESTRICTED()) {
+		SBOX_SET_SECURITY_ERR();
+		return -EPERM;
+	}
+
 	ret = -EINVAL;
 	if (plen > 1024 * 1024 - 1)
 		goto error;
@@ -158,6 +163,11 @@ SYSCALL_DEFINE4(request_key, const char 
 	char type[32], *description, *callout_info;
 	long ret;
 
+	if (SBOX_IS_RESTRICTED()) {
+		SBOX_SET_SECURITY_ERR();
+		return -EPERM;
+	}
+
 	/* pull the type into kernel space */
 	ret = key_get_type_from_user(type, _type, sizeof(type));
 	if (ret < 0)
@@ -1345,6 +1355,11 @@ error_keyring:
 SYSCALL_DEFINE5(keyctl, int, option, unsigned long, arg2, unsigned long, arg3,
 		unsigned long, arg4, unsigned long, arg5)
 {
+	if (SBOX_IS_RESTRICTED()) {
+		SBOX_SET_SECURITY_ERR();
+		return -EPERM;
+	}
+
 	switch (option) {
 	case KEYCTL_GET_KEYRING_ID:
 		return keyctl_get_keyring_ID((key_serial_t) arg2,
diff -ruNp linux-2.6.34.5/tools/make-syscall-table.cpp linux-2.6.34.5-cher1/tools/make-syscall-table.cpp
--- linux-2.6.34.5/tools/make-syscall-table.cpp	1970-01-01 03:00:00.000000000 +0300
+++ linux-2.6.34.5-cher1/tools/make-syscall-table.cpp	2010-08-26 14:45:12.750710944 +0400
@@ -0,0 +1,339 @@
+#include <stdio.h>
+#include <stdarg.h>
+#include <stdlib.h>
+#include <ctype.h>
+#include <string.h>
+#include <string>
+#include <iostream>
+#include <map>
+
+using namespace std;
+
+void
+die(const char *msg, ...)
+    __attribute__((noreturn, format(printf, 1, 2)));
+void
+die(const char *format, ...)
+{
+    va_list args;
+    char buf[1024];
+
+    va_start(args, format);
+    vsnprintf(buf, sizeof(buf), format, args);
+    va_end(args);
+
+    fprintf(stderr, "fatal: %s\n", buf);
+
+    exit(1);
+}
+
+class SyscallName
+{
+public:
+    SyscallName(const string &name_, const string &arch_)
+        : name(name_),
+          arch(arch_)
+    {
+    }
+
+    string get_name() const { return name; }
+    string get_arch() const { return arch; }
+
+    friend bool operator == (const SyscallName &v1, const SyscallName &v2);
+    friend bool operator != (const SyscallName &v1, const SyscallName &v2);
+    friend bool operator <= (const SyscallName &v1, const SyscallName &v2);
+    friend bool operator < (const SyscallName &v1, const SyscallName &v2);
+    friend bool operator > (const SyscallName &v1, const SyscallName &v2);
+    friend bool operator >= (const SyscallName &v1, const SyscallName &v2);
+
+private:
+    string name;
+    string arch;
+};
+
+bool
+operator == (const SyscallName &v1, const SyscallName &v2)
+{
+    return v1.name == v2.name && v1.arch == v2.arch;
+}
+
+bool
+operator != (const SyscallName &v1, const SyscallName &v2)
+{
+    return v1.name != v2.name || v1.arch != v2.arch;
+}
+
+bool
+operator < (const SyscallName &v1, const SyscallName &v2)
+{
+    if (v1.name == v2.name) return v1.arch < v2.arch;
+    return v1.name < v2.name;
+}
+
+bool
+operator <= (const SyscallName &v1, const SyscallName &v2)
+{
+    if (v1.name == v2.name) return v1.arch <= v2.arch;
+    return v1.name <= v2.name;
+}
+
+bool
+operator > (const SyscallName &v1, const SyscallName &v2)
+{
+    if (v1.name == v2.name) return v1.arch > v2.arch;
+    return v1.name > v2.name;
+}
+
+bool
+operator >= (const SyscallName &v1, const SyscallName &v2)
+{
+    if (v1.name == v2.name) return v1.arch >= v2.arch;
+    return v1.name >= v2.name;
+}
+
+enum SyscallMode
+{
+    UNDEFINED,
+    ALLOWED,
+    RESTRICTED,
+    SECURED,
+    REDIRECT,
+    UNIMPLEMENTED
+};
+
+class SyscallInfo
+{
+public:
+    SyscallInfo()
+    {
+    }
+
+    SyscallInfo(string source_file_, SyscallMode mode_, string ref_func_)
+        : source_file(source_file_),
+          mode(mode_),
+          ref_func(ref_func_)
+    {
+    }
+
+    string get_source_file() const { return source_file; }
+    SyscallMode get_mode() const { return mode; }
+    string get_mode_str() const
+    {
+        switch (mode) {
+        case ALLOWED:
+            return "OK ";
+        case RESTRICTED:
+            return "CAP";
+        case SECURED:
+            return "SEC";
+        case REDIRECT:
+            return "RED";
+        case UNIMPLEMENTED:
+            return "---";
+        default:
+            return "???";
+        }
+    }
+    string get_ref_func() const { return ref_func; }
+
+    void set_mode(SyscallMode mode_)
+    {
+        mode = mode_;
+    }
+    void set_ref_func(string ref_func_)
+    {
+        ref_func = ref_func_;
+    }
+
+private:
+    string source_file;
+    SyscallMode mode;
+    string ref_func;
+};
+
+map<SyscallName, SyscallInfo> sysinfos;
+
+void
+read_in_file(const char *path)
+{
+    FILE *in = NULL;
+    char buf[1024];
+    char func_name[sizeof(buf)];
+    char mode_str[sizeof(buf)];
+    char ref_str[sizeof(buf)];
+    size_t len;
+    int lineno = 0;
+    string current_file_name;
+
+    if (!(in = fopen(path, "r"))) die("cannot open `%s'", path);
+    while (fgets(buf, sizeof(buf), in)) {
+        len = strlen(buf);
+        lineno++;
+        if (len > sizeof(buf) - 4) die("[%d] line is too long", lineno);
+        while (len > 0 && isspace(buf[len - 1])) {
+            len--;
+        }
+        buf[len] = 0;
+        if (!len) continue;
+
+        if (buf[len - 1] == ':') {
+            buf[--len] = 0;
+            if (!len) die("[%d] invalid file name", lineno);
+            current_file_name = string(buf);
+            //cerr << "File: " << current_file_name << endl;
+            continue;
+        }
+
+        int n = 0;
+        char const *p = buf;
+        if (sscanf(p, "%s%n", func_name, &n) != 1)
+            die("[%d] cannot parse function name", lineno);
+        p += n;
+        if (sscanf(p, "%s%n", mode_str, &n) != 1) die("[%d] cannot parse mode string", lineno);
+        p += n;
+        ref_str[0] = 0;
+	sscanf(p, "%s%n", ref_str, &n);
+        p += n;
+
+        SyscallMode mode = UNDEFINED;
+
+        if (!strcmp(mode_str, "allowed")) {
+            mode = ALLOWED;
+        } else if (!strcmp(mode_str, "restricted")) {
+            mode = RESTRICTED;
+        } else if (!strcmp(mode_str, "secured")) {
+            mode = SECURED;
+        } else if (!strcmp(mode_str, "redirect")) {
+            mode = REDIRECT;
+        } else if (!strcmp(mode_str, "unimpl")) {
+            mode = UNIMPLEMENTED;
+        } else {
+            die("[%d] invalid mode line %s", lineno, mode_str);
+        }
+
+        string ref_func;
+        if (mode == REDIRECT)
+            ref_func = ref_str;
+
+        SyscallName sn(string(func_name), "");
+        SyscallInfo si(current_file_name, mode, ref_func);
+
+        sysinfos[sn] = si;
+    }
+    fclose(in); in = NULL;
+}
+
+void
+handle_redirects(void)
+{
+    bool flag = true;
+
+    while (flag) {
+        flag = false;
+
+        map<SyscallName, SyscallInfo>::const_iterator ii;
+        for (ii = sysinfos.begin(); ii != sysinfos.end(); ++ii) {
+            SyscallName sn = ii->first;
+            SyscallInfo si = ii->second;
+            if (si.get_mode() != REDIRECT) continue;
+
+            SyscallName sn2(si.get_ref_func(), "");
+            map<SyscallName, SyscallInfo>::const_iterator ii2;
+            ii2 = sysinfos.find(sn2);
+            if (ii2 == sysinfos.end()) die("invalid redirect %s", si.get_ref_func().c_str());
+            SyscallInfo si2 = ii2->second;
+            si.set_mode(si2.get_mode());
+            si.set_ref_func(si2.get_ref_func());
+            sysinfos[sn] = si;
+            flag = true;
+
+            //cerr << "redirect: " << sn.get_name() << "->" << si2.get_ref_func() << endl;
+        }
+    }
+}
+
+void
+process_file(const char *path)
+{
+    char out_name[1024];
+    FILE *in = NULL;
+    FILE *out = NULL;
+    char buf[1024];
+    size_t len;
+    char syscall_name[sizeof(buf)];
+
+    snprintf(out_name, sizeof(out_name), "%s.out", path);
+
+    if (!(in = fopen(path, "r"))) die("cannot open input file %s", path);
+    if (!(out = fopen(out_name, "w"))) die("cannot open output file %s", out_name);
+
+    while (fgets(buf, sizeof(buf), in)) {
+        len = strlen(buf);
+        if (len > sizeof(buf) - 4) die("line is too long in %s", path);
+        while (len > 0 && isspace(buf[len - 1])) {
+            len--;
+        }
+        buf[len] = 0;
+        if (len == 0) {
+            fprintf(out, "\n");
+            continue;
+        }
+
+        sscanf(buf, "%s", syscall_name);
+        map<SyscallName, SyscallInfo>::const_iterator ii;
+        ii = sysinfos.find(SyscallName(string(syscall_name), ""));
+        if (ii == sysinfos.end()) {
+            fprintf(out, "%s\n", buf);
+            continue;
+        }
+
+        SyscallName sn = ii->first;
+        SyscallInfo si = ii->second;
+
+        if (si.get_mode() == UNIMPLEMENTED) {
+            fprintf(out, "%-32s%-8s\n",
+                    sn.get_name().c_str(),
+                    si.get_mode_str().c_str());
+            continue;
+        }
+
+        fprintf(out, "%-32s%-8s%s\n",
+                sn.get_name().c_str(),
+                si.get_mode_str().c_str(),
+                si.get_source_file().c_str());
+    }
+
+    fclose(in); in = NULL;
+    fclose(out); out = NULL;
+}
+
+int main(int argc, char **argv)
+{
+    if (argc <= 1) die("invalid number of arguments");
+    read_in_file(argv[1]);
+
+    handle_redirects();
+
+    for (int i = 2; i < argc; ++i) {
+        process_file(argv[i]);
+    }
+
+    /*
+    map<SyscallName, SyscallInfo>::const_iterator ii;
+    for (ii = sysinfos.begin(); ii != sysinfos.end(); ++ii) {
+        SyscallName sn = ii->first;
+        SyscallInfo si = ii->second;
+
+        cerr << sn.get_name() << "," << si.get_source_file() << "," << si.get_mode_str() << endl;
+    }
+    */
+
+    return 0;
+}
+
+/*
+ * Local variables:
+ *  compile-command: "g++ -g -Wall make-syscall-table.cpp -o make-syscall-table"
+ *  c-basic-offset: 4
+ * End:
+ */
